import es, time, effectlib, popuplib, playerlib
import os, cPickle

owners = {} # {index: {userid:userid, ding:float}}
boxes = []

admins = ['STEAM_ID_LAN']

addondir = str(es.ServerVar('eventscripts_addondir'))
currentmap = es.ServerVar('eventscripts_currentmap')

class ManagementInterface:
    def __init__(self):
        self.resetData()
        
    def resetData(self):
        self.point1 = False
        self.point2 = False
        self.userid = 0
    def create_box(self, userid):
        self.resetData()
        self.userid = userid
        self.popup(userid)
        playerlib.getPlayer(self.userid).noclip = 1
        
    def popup(self, userid):
        if not self.point2:
            if popuplib.exists('bb_createbox'): popuplib.delete('bb_createbox')
            p = popuplib.create('bb_createbox')
            p.addline('Box Control')
            p.addline('-----------------')
            if not self.point1:
                p.addline('->1 - Set Point 1')
            else:
                p.addline('->1 - Set Point 2')
            p.addline('->2 - Cancel')
            p.menuselect = self.step
            p.send(userid)
    
    def step(self, userid, choice, popupname):
        if int(choice) == 1:
            if not self.point1:
                self.point1 = es.getplayerlocation(userid)
                tell(userid, 'Set point 1')
                self.popup(userid)
            else:
                self.point2 = es.getplayerlocation(userid)
                tell(userid, 'Set point 2')
                self.createBox()
        elif int(choice) == 2:
            self.resetData()
        else:
            self.popup(userid)
            
    def createBox(self):
        boxes.append(Box(self.point1, self.point2))
        effectlib.drawBox(self.point1, self.point2, seconds=10) # debug stuff.
        playerlib.getPlayer(self.userid).noclip = 0
        self.resetData()
        exportData()
interface = ManagementInterface()


def load():
    importData()
    es.addons.registerTickListener(tick)
    
def unload():
    es.addons.unregisterTickListener(tick)
    
def es_map_start(ev):
    importData()
    
def tick():
    global owners
    locs = []
    indexs = list(owners)
    t = time.time()
    for index in indexs:
        if owners[index]['ding'] < t:
            pos = es.getindexprop(index, 'CBaseEntity.m_vecOrigin')
            if not pos is None:
                locs.append( ((map(lambda x: float(x), pos.split(','))), index ) )
            
    for loc in locs:
        l, index = loc
        if loc != (0, 0, 0):
            for box in boxes:
                if box.inBox(l):
                    owners[index]['ding'] = t+3
                    userid = owners[index]['userid']
                    es.msg('%s scored!'%es.getplayername(userid))
                    es.emitsound('player', userid, 'buttons/blip2.wav', 0.8, 0.6)
                    p1 = (box.hx, box.hy, box.hz)
                    p2 =  (box.lx, box.ly, box.lz)
                    effectlib.drawBox(p1, p2, red=0, green=255, blue=0, seconds=3)
                
def exportData():
    data = []
    for x in boxes:
        p1 = (x.hx, x.hy, x.hz)
        p2 =  (x.lx, x.ly, x.lz)
        data.append((p1, p2))
    
    if not os.path.isdir(addondir + '/c4score/maps/'):
        os.mkdir(addondir + '/c4score/maps/')
    a = open(addondir + '/c4score/maps/%s.db'%currentmap, 'wb')
    cPickle.dump(data, a)
    a.close()
    es.dbgmsg(0, 'Saved c4score data for map %s'%currentmap)
    
def importData():
    while boxes:
        boxes.pop(0)
    
    p = addondir + '/c4score/maps/%s.db'%currentmap
    if os.path.isfile(p):
        a = open(p, 'rb')
        data = cPickle.load(a)
        a.close()
        
        for x in data:
            boxes.append(Box(x[0], x[1]))
            
        es.dbgmsg(0, 'Loaded c4score data for map %s'%currentmap)
    else:
        es.dbgmsg(0, 'c4score has no data for %s'%currentmap)
        
        
class Box:
    def __init__(self, location1, location2):
        self.moveto(location1, location2)
        
    def moveto(self, location1, location2):
        x, y, z = location1
        x1, y1, z1 = location2
        self.lx = min(x, x1)
        self.ly = min(y, y1)
        self.lz = min(z, z1)
        self.hx = max(x, x1)
        self.hy = max(y, y1)
        self.hz = max(z, z1)
    
    def inBox(self, location):
        x, y, z = location
        if self.lx <= x <= self.hx:
            if self.ly <= y <= self.hy:
                if self.lz <= z <= self.hz:
                    return True

def player_say(ev):
    global workid, pos1, pos2
    if es.getplayersteamid(ev['userid']) in admins:
        if ev['text'] == 'createbox':
            interface.create_box(ev['userid'])
            
def tell(userid, text):
    es.tell(userid, text)
        
def round_end(ev):
    global owners
    owners = {}
    
def item_pickup(ev):
    global owners
    if ev['item'] in ('c4', 'deagle'):
        index = getIndex(ev['userid'], ev['item'])
        if not index is None:
            owners[str(index)] = {'userid':ev['userid'], 'ding': 0}
            #es.msg('%s picked up a %s'%(es.getplayername(ev['userid']), ev['item']))
            
    if ev['item'] == 'c4':
        es.sexec(ev['userid'], 'use weapon_c4')
        
def getIndex(userid, weapon):
    if not weapon.startswith('weapon_'):
        weapon = 'weapon_' + weapon
    
    handle = es.getplayerhandle(userid)
    for index in es.createentitylist(weapon):
        ehandle = es.getindexprop(index, 'CBaseEntity.m_hOwnerEntity')
        if handle == ehandle:
            return index
    
    return None